/****************************************************************************************
  strmanip.c                                                 2009.05.18 tesakai
****************************************************************************************/
#include "strmanip.h"

/******************************************************************************
  fgetls [there seems to be a bug so do not use it]

return value: 1 (OK)
              0 (EOF)
	     -1 (NG)
******************************************************************************/
int fgetls( p, fp )
    char **p;
    FILE *fp;
{
    struct strlist *ps1 = NULL;
    struct strlist **pp;
    struct strlist **qq;
    struct strlist *ps2;
    char *buf;
    int count = 0;

    pp = &ps1;
    while( 1 )
    {
        if( ( buf = ( char * ) malloc( BUFSIZ + 1 ) ) == NULL )
	{
	    return( -1 );
	}
        if( fgets( buf, BUFSIZ + 1, fp ) )
        {
	    if( ( qq = addtostrlist( pp, buf ) ) == NULL )
	    {
		return( -1 );
	    }
            pp = qq;
            if( *( buf + strlen( buf ) - 1 ) == '\n' )
            {
                break;
            }
            count++;
        }
        else
        {
            p = NULL;
            return( 0 );
        }
    }

    if( ( *p = ( char * ) malloc( BUFSIZ * count + strlen( buf ) + 1 ) )
         == NULL )
    {
	return( -1 );
    }

    strcpy( *p, "" );
    ps2 = ps1;
    while( ps2 )
    {
        strcat( *p, ps2->string );
        ps2 = ps2->next;
    }
    
    freestrlist( &ps1 );
    return( 1 );
    
}/* of fgetls */


/******************************************************************************
  strlistmatch

return value: 1 (match)
              0 (no match)
******************************************************************************/
int strlistmatch( list, str )
    struct strlist *list;
    const char *str;
{
    struct strlist *p;

    p = list;
    while( p ){
	if( !strcmp( p->string, str ) )
	    return( 1 );
	p = p->next;
    }
    
    return( 0 );

}/* of strlistmatch */

/******************************************************************************
  str2strlist

return value: strlist size (>= 0) (OK)
             -1 (NG)
******************************************************************************/
int str2strlist( str, sep, list )
    const char *str;
    const char *sep;
    struct strlist **list;
{
    char *buf, *p, *buf2;
    struct strlist **pp1, **pp2;
    int count = 0;

    if( str == NULL )
	return( -1 );

    if( ( buf = strdup( str ) ) == NULL ){  
#ifdef OUTERR	
	fprintf( stderr, "strdup failed: %s\n", str );
#endif	
	return( -1 );
    }
    if( ( p = strtok( buf, sep ) ) == NULL ){
#ifdef OUTERR	
	fprintf( stderr, "strtok failed: %s\n", str );
#endif	
	return( -1 );
    }

    pp1 = list;
    do{
	if( ( buf2 = strdup( p ) ) == NULL ){

#ifdef OUTERR	
	    fprintf( stderr, "strdup failed: %s\n", p );
#endif	
	    return( -1 );
	}
	if( ( pp2 = addtostrlist( pp1, buf2 ) ) == NULL ){
#ifdef OUTERR	
	    fprintf( stderr, "addtostrlist failed: %s\n", buf2 );
#endif	
	    return( -1 );
	}
	pp1 = pp2;
	count++;
	
    }while( ( p = strtok( NULL, sep ) ) != NULL );

    free( buf );
    return( count );

}/* of str2strlist */

/******************************************************************************
  file2strlist

return value: strlit size (>=0)
             -1 (NG)
******************************************************************************/
int file2strlist( filename, p )
    const char *filename;
    struct strlist **p;
{
    FILE *f;
    struct strlist **pp1, **pp2;
    /*    char *line, *buf; */
    char line[ BUFSIZ + 1 ];
    char *pos;
    char *buf;
    int count = 0;

    if( filename == NULL )
	return( -1 );

    if( ( f = fopen( filename, "r" ) ) == NULL ){
#ifdef OUTERR	
	fprintf( stderr, "Cannot open %s\n", filename );
#endif	
	return( -1 );
    }

    pp1 = p;

    /*    while( fgetls( &line, f ) ){ */
    while( fgets( line, sizeof( line ), f ) ){

      if( ( pos = strchr( line, '\n' ) ) == NULL ){
#ifdef OUTERR	
	fprintf( stderr, "Line too long: %s\n", line );
#endif	
	return( -1 );
      }
      *pos = '\0';

      if( ( buf = strdup( line ) ) == NULL ){
#ifdef OUTERR	
	fprintf( stderr, "strdup for buf failed\n" );
#endif	
	return( -1 );
      }
      if( ( pp2 = addtostrlist( pp1, buf ) ) == NULL ){
#ifdef OUTERR	
	fprintf( stderr, "addtostrlist failed:%s\n", buf );
#endif	
	return( -1 );
      }
      pp1 = pp2;
      count++;
    }

    fclose( f );
    return( count );

}/* of file2strlist */

/******************************************************************************
  addtostrlist

******************************************************************************/
struct strlist **addtostrlist( p, s )
    struct strlist **p;
    char *s;
{
    struct strlist *q;

    if( s == NULL )
	return( NULL );
    
    if( ( q = ( struct strlist * )
	 malloc( sizeof( struct strlist ) ) ) == NULL )
    {
#ifdef OUTERR	
	fprintf( stderr, "malloc failed: %s\n", s );
#endif	
	return( NULL );
    }

    q->string = s;
    q->next = NULL;
    ( *p ) = q;
    return( &( q->next ) );

}/* of addtostrlist */

/******************************************************************************
  addtostrlonglist

******************************************************************************/
struct strlonglist **addtostrlonglist( p, s, num )
    struct strlonglist **p;
    char *s;
    long num;
{
    struct strlonglist *q;

    if( s == NULL )
	return( NULL );
    
    if( ( q = ( struct strlonglist * )
	 malloc( sizeof( struct strlonglist ) ) ) == NULL )
    {
#ifdef OUTERR	
	fprintf( stderr, "malloc failed: %s\n", s );
#endif	
	return( NULL );
    }

    q->string = s;
    q->num = num;
    q->next = NULL;
    ( *p ) = q;
    return( &( q->next ) );

}/* of addtostrlonglist */


/******************************************************************************
  addtouniqstrlist
return value:
 1
 0
-1(ERROR)
******************************************************************************/
int addtouniqstrlist( p, s )
    struct strlist **p; /* i/o */
    char *s;            
{
    struct strlist *p1, *p2;

    p1 = *p;

    if( s == NULL )
	return( -1 );

    if( ( p1 == NULL ) || 
        ( strcmp( p1->string, s ) > 0 ) ){ 
	if( ( p2 = ( struct strlist * )
	     malloc( sizeof( struct strlist ) ) ) == NULL ){
#ifdef OUTERR	
	    fprintf( stderr, "malloc failed: %s\n", s );
#endif	
	    return( -1 );
	}
	p2->string = s;
	p2->next = p1;
	*p = p2;
	return( 1 ); /* added a new record */
    }

    while( p1 ){
	if( !strcmp( p1->string, s ) ){ /* record already exists */
	    return( 0 ); /* do nothing and return successfully */
	}
	if( ( ( p1->next ) == NULL ) || 
	    ( strcmp( ( p1->next )->string, s ) > 0 ) ){ 
	    if( ( p2 = ( struct strlist * )
		 malloc( sizeof( struct strlist ) ) ) == NULL ){
#ifdef OUTERR	
		fprintf( stderr, "malloc failed: %s\n", s );
#endif	
		return( -1 );
	    }
	    p2->string = s;
	    p2->next = p1->next;
	    p1->next = p2;
	    return( 1 ); /* added a new record */
	}
	p1 = p1->next;
    }

    return( -1 ); /* should not reach this line */

}/* of addtouniqstrlist */

/******************************************************************************
  addtouniqstrlonglist
return value:
 1
 0
-1(ERROR)
******************************************************************************/
int addtouniqstrlonglist( p, s, num )
    struct strlonglist **p; /* i/o */
    char *s;            
    long num;           /* i */
{
    struct strlonglist *p1, *p2;

    p1 = *p;

    if( s == NULL )
	return( -1 );

    if( ( p1 == NULL ) || 
        ( strcmp( p1->string, s ) > 0 ) ){ 
	if( ( p2 = ( struct strlonglist * )
	     malloc( sizeof( struct strlonglist ) ) ) == NULL ){
#ifdef OUTERR	
	    fprintf( stderr, "malloc failed: %s\n", s );
#endif	
	    return( -1 );
	}
	p2->string = s;
	p2->num = num;
	p2->next = p1;
	*p = p2;
	return( 1 ); /* added a new record */
    }

    while( p1 ){
	if( !strcmp( p1->string, s ) ){ /* record already exists */
	    p1->num = num;
	    return( 0 ); /* update long and return successfully */
	}
	if( ( ( p1->next ) == NULL ) ||
	    ( strcmp( ( p1->next )->string, s ) > 0 ) ){
	    if( ( p2 = ( struct strlonglist * )
		 malloc( sizeof( struct strlonglist ) ) ) == NULL ){
#ifdef OUTERR	
		fprintf( stderr, "malloc failed: %s\n", s );
#endif	
		return( -1 );
	    }
	    p2->string = s;
	    p2->num = num;
	    p2->next = p1->next;
	    p1->next = p2;
	    return( 1 ); /* added a new record */
	}
	p1 = p1->next;
    }

    return( -1 ); /* should not reach this line */

}/* of addtouniq_strlonglist */

/******************************************************************************
  freestrlist

return value: 0 (OK)
******************************************************************************/
int freestrlist( p )
    struct strlist **p;
{
    struct strlist *p1, *p2;

    p1 = *p;
    while( p1 )
    {
        p2 = p1;
        p1 = p1->next;
        free( p2->string );
        free( p2 );
    }

    *p = NULL;
    return( 0 );
    
}/* of freestrlist */

/******************************************************************************
  freestrlonglist

return value: 0 (OK)
******************************************************************************/
int freestrlonglist( p )
    struct strlonglist **p;
{
    struct strlonglist *p1, *p2;

    p1 = *p;
    while( p1 )
    {
        p2 = p1;
        p1 = p1->next;
        free( p2->string );
        free( p2 );
    }

    *p = NULL;
    return( 0 );
    
}/* of freestrlonglist */


/******************************************************************************
  fprintstrlist
return value: 0 (OK)  
******************************************************************************/
int fprintstrlist( fp, p )
    FILE *fp;
    struct strlist *p;
{
    struct strlist *p1;

    p1 = p ;

    while( p1 )
    {
        fprintf( fp, "%s\n", p1->string );
        p1 = p1->next;
    }

    return( 0 );

}/* of fprintstrlist */

/******************************************************************************
  fprintstrlonglist
return value: 0 (OK)  
******************************************************************************/
int fprintstrlonglist( fp, p )
    FILE *fp;
    struct strlonglist *p;
{
    struct strlonglist *p1;

    p1 = p ;

    while( p1 )
    {
        fprintf( fp, "%s %ld\n", p1->string, p1->num );
        p1 = p1->next;
    }

    return( 0 );

}/* of fprintstrlonglist */


/******************************************************************************
  rmnewl

return value: 1 (replaced)
              0 (did nothing)
******************************************************************************/
int rmnewl( p )
     char *p;
{
    long i;
    long len = strlen( p );
    int retv = 0;

    if( p == NULL )
        return( -1 );

    for( i = len - 1; i >= 0; i-- ){
  
	if( p[ i ] == '\n' ){
	    p[ i ] = '\0';
	    retv = 1;
	}
	else
	    break;
    }

    return( retv );
    
}/* of rmnewl */


/******************************************************************************
  strmrg5

return value:
 0 (OK)
-1 (NG)
******************************************************************************/
int strmrg5( s, s1, s2, s3, s4, s5 )
    char **s; /* o */
    const char *s1;
    const char *s2;
    const char *s3;
    const char *s4;
    const char *s5;
{
    if( s1 == NULL || s2 == NULL || s3 == NULL || s4 == NULL || s5 == NULL )
	return( -1 );
    
    if( ( *s = ( char * ) malloc( strlen( s1 ) +
				 strlen( s2 ) +
				 strlen( s3 ) +
				 strlen( s4 ) +
				 strlen( s5 ) + 1 ) ) == NULL ){
#ifdef OUTERR	
	fprintf( stderr, "malloc failed\n" );
#endif	
	return( -1 );
    }
    strcpy( *s, s1 );
    strcat( *s, s2 );
    strcat( *s, s3 );
    strcat( *s, s4 );
    strcat( *s, s5 );
    strcat( *s, "" );
    return( 0 );
    
}/* of strmrg5 */

/******************************************************************************
  strmrg4

return value:
 0 (OK)
-1 (NG)
******************************************************************************/
int strmrg4( s, s1, s2, s3, s4 )
    char **s; /* o */
    const char *s1;
    const char *s2;
    const char *s3;
    const char *s4;
{
    if( s1 == NULL || s2 == NULL || s3 == NULL || s4 == NULL )
	return( -1 );
    
    if( ( *s = ( char * ) malloc( strlen( s1 ) +
				 strlen( s2 ) +
				 strlen( s3 ) +
				 strlen( s4 ) + 1 ) ) == NULL ){
#ifdef OUTERR	
	fprintf( stderr, "malloc failed\n" );
#endif	
	return( -1 );
    }
    strcpy( *s, s1 );
    strcat( *s, s2 );
    strcat( *s, s3 );
    strcat( *s, s4 );
    strcat( *s, "" );
    return( 0 );
    
}/* of strmrg4 */

/******************************************************************************
  strmrg3

return value:
 0 (OK)
-1 (NG)
******************************************************************************/
int strmrg3( s, s1, s2, s3 )
    char **s; /* o */
    const char *s1;
    const char *s2;
    const char *s3;
{
    if( s1 == NULL || s2 == NULL || s3 == NULL )
	return( -1 );
    
    if( ( *s = ( char * ) malloc( strlen( s1 ) +
				 strlen( s2 ) +
				 strlen( s3 ) + 1 ) ) == NULL ){
#ifdef OUTERR	
	fprintf( stderr, "malloc failed\n" );
#endif	
	return( -1 );
    }
    strcpy( *s, s1 );
    strcat( *s, s2 );
    strcat( *s, s3 );
    strcat( *s, "" );
    return( 0 );
    
}/* of strmrg3 */


/******************************************************************************
  strmrg2

return value:
 0 (OK)
-1 (NG)
******************************************************************************/
int strmrg2( s, s1, s2 )
    char **s; /* o */
    const char *s1;
    const char *s2;
{
    if( s1 == NULL || s2 == NULL )
	return( -1 );
    
    if( ( *s = ( char * ) malloc( strlen( s1 ) +
				 strlen( s2 ) + 1 ) ) == NULL )
    {
#ifdef OUTERR	
	fprintf( stderr, "malloc failed\n" );
#endif	
	return( -1 );
    }
    strcpy( *s, s1 );
    strcat( *s, s2 );
    strcat( *s, "" );
    return( 0 );
    
}/* of strmrg2 */

/******************************************************************************
  strnmalcpy
malloc -> strncpy  

return value: 0
             -1
******************************************************************************/
int strnmalcpy( s1, s2, len )
    char **s1;  /* o */
    const char *s2;   
    long len;    
{
    if( s2 == NULL )
	return( -1 );
    
    if( ( ( *s1 ) = ( char * ) malloc( len + 1 ) ) == NULL )
    {
#ifdef OUTERR	
	fprintf( stderr, "malloc failed\n" );
#endif	
	return(  -1 );
    }
    strncpy( ( *s1 ), s2, len );
    *( ( *s1 ) + len ) = '\0';
    return( 0 );
    
}/* of strnmalcpy */


/******************************************************************************
  strcatrep

return value: 0 (OK)
             -1 (NG)
******************************************************************************/
int strcatrep( p1, p2 )
    char **p1; /* i/o */
    const char *p2;  /* i */
{
    char *p;

    if( p2 == NULL )
	return( -1 );

    if( *p1 == NULL ){
	if( ( *p1 = strdup( p2 ) ) == NULL ){
#ifdef OUTERR	
	    fprintf( stderr, "strdup failed: %s\n", p2 );
#endif	
	    return( -1 );
	}
    }
    else{ /* *p1 != NULL */
	if( ( p = strdup( *p1 ) ) == NULL ){
#ifdef OUTERR	
	    fprintf( stderr, "strdup failed: %s\n", p2 );
#endif	
	    return( -1 );
	}
	free( *p1 );
	if( ( *p1 = ( char * ) malloc( strlen( p ) + strlen( p2 ) + 1 ) )
	   == NULL ){
#ifdef OUTERR	
	    fprintf( stderr, "malloc failed: %s\n", p2 );
#endif	
	    free( p );
	    return( -1 );
	}
	strcpy( *p1, p );
	strcat( *p1, p2 );
	strcat( *p1, "" );
	free( p );
    }

    return( 0 );

}/* of strcatrep */

/******************************************************************************
  strcatrep2

return value: 0 (OK)
             -1 (NG)
******************************************************************************/
int strcatrep2( p1, p2, p3 )
    char **p1; /* i/o */
    const char *p2;  /* i */
    const char *p3;  /* i */
{
    char *p;

    if( p2 == NULL || p3 == NULL )
	return( -1 );

    if( *p1 == NULL ){
	if( ( *p1 = ( char * )malloc( strlen( p2 ) + strlen( p3 ) + 1 ) )
	   == NULL ){
#ifdef OUTERR	
	    fprintf( stderr, "malloc failed: %s %s\n", p2, p3 );
#endif	
	    return( -1 );
	}
	strcpy( *p1, p2 );
	strcat( *p1, p3 );
	strcat( *p1, "" );
    }
    else{ /* *p1 != NULL */
	if( ( p = strdup( *p1 ) ) == NULL ){
#ifdef OUTERR	
	    fprintf( stderr, "strdup failed: %s\n", p2 );
#endif	
	    return( -1 );
	}
	free( *p1 );
	if( ( *p1 = ( char * )malloc( strlen( p ) + strlen( p2 ) +
				     strlen( p3 ) + 1 ) ) == NULL ){
#ifdef OUTERR	
	    fprintf( stderr, "malloc failed: %s %s\n", p2, p3 );
#endif	
	    free( p );
	    return( -1 );
	}
	strcpy( *p1, p );
	strcat( *p1, p2 );
	strcat( *p1, p3 );
	strcat( *p1, "" );
	free( p );
    }

    return( 0 );

}/* of strcatrep */
