/****************************************************************************************
  strmanip.h                                                 
****************************************************************************************/
#ifndef _STRMANIP_H_
#define _STRMANIP_H_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <ctype.h>

struct strlist
{
  char *string;
  struct strlist *next;
};

struct strlonglist
{
  char *string;
  long num;
  struct strlonglist *next;
};

#ifdef __cplusplus
extern "C" {
#endif

  extern int fgetls( char**, FILE* );

  extern int strlistmatch( struct strlist*, const char* );

  extern int str2strlist( const char*, const char*, struct strlist** );

  extern int file2strlist( const char*, struct strlist** );

  extern struct strlist **addtostrlist( struct strlist**, char* );

  extern struct strlonglist **addtostrlonglist( struct strlonglist**,
						char*, long );

  extern int addtouniqstrlist( struct strlist**, char* );

  extern int addtouniqstrlonglist( struct strlonglist**, char*, long );

  extern int freestrlist( struct strlist** );

  extern int freestrlonglist( struct strlonglist** );

  extern int fprintstrlist( FILE*, struct strlist* );

  extern int fprintstrlonglist( FILE*, struct strlonglist* );

  extern int rmnewl( char* );

  extern int strmrg5( char**, const char*, const char*, const char*,
		      const char*, const char* );

  extern int strmrg4( char**, const char*, const char*, const char*,
		      const char* );

  extern int strmrg3( char**, const char*, const char*, const char* );

  extern int strmrg2( char**, const char*, const char* );

  extern int strnmalcpy( char**, const char*, long );

  extern int strcatrep( char**, const char* );

  extern int strcatrep2( char**, const char*, const char* );

#ifdef __cplusplus
}
#endif

#endif
